From: Simon McVittie <smcv@debian.org>
Date: Sat, 4 Feb 2017 14:42:19 +0000
Subject: Fix compatibility with changed UNIX socket API

Based on patches from Mathieu Parent and Courtney Bane.
---
 host/control.lua | 15 +++++++++------
 host/ekeydctl.in |  4 ++--
 2 files changed, 11 insertions(+), 8 deletions(-)

diff --git a/host/control.lua b/host/control.lua
index 7b9b1b8..48723ec 100644
--- a/host/control.lua
+++ b/host/control.lua
@@ -38,16 +38,19 @@ local PROTOCOL_VERSION = "1"
 local dos_callcount = 0
 
 -- Libraries we need
-require "socket"
+local socket = require "socket"
 
 local have_unix_domain_sockets = false
-function tryload_unix()
-   require "socket.unix"
-   have_unix_domain_sockets = true
+local ok, unix = pcall(require, "socket.unix")
+if ok then
+   if type(unix) == "function" then
+      socket.unix = unix
+   else
+      socket.unix = unix.stream or unix.tcp
+   end
+   have_unix_domain_sockets = socket.unix ~= nil
 end
 
-pcall(tryload_unix)
-
 local protectedenv = {}
 
 -- Control socket interface
diff --git a/host/ekeydctl.in b/host/ekeydctl.in
index 9292ac6..801db7c 100755
--- a/host/ekeydctl.in
+++ b/host/ekeydctl.in
@@ -1,11 +1,11 @@
 #!/usr/bin/env lua@LUA_V@
 -- -*- Lua -*-
 
-require "socket"
+local socket = require "socket"
 
 -- Try to load the UNIX domain sockets support
 pcall(function()
-	 require "socket.unix"
+	 socket.unix = require "socket.unix"
       end)
 
 
